/*
 * SNU 4190.310 Programming Languages (Fall 2006)
 *
 * K- Interpreter I
 */
  
%token <int> NUM
%token TRUE FALSE
%token <string> ID
%token PLUS MINUS STAR SLASH EQUAL LB NOT COLONEQ SEMICOLON IF THEN ELSE END
%token WHILE DO FOR TO LET IN READ WRITE
%token LP RP
%token EOF

%nonassoc IN
%left SEMICOLON
%nonassoc DO
%nonassoc THEN
%nonassoc ELSE
%right COLONEQ
%right WRITE         
%left EQUAL LB  
%left PLUS MINUS
%left STAR SLASH
%right NOT

%start program
%type <Keval.exp> program

%%

program:
       expr EOF { $1 }
    ;

expr: 
      LP expr RP { $2 }
    | MINUS NUM { Keval.NUM (-$2) }
    | NUM { Keval.NUM ($1) }
    | TRUE { Keval.TRUE }
    | FALSE { Keval.FALSE }
    | LP RP { Keval.UNIT }
    | ID { Keval.VAR ($1) }
    | expr PLUS expr { Keval.ADD ($1, $3) }
    | expr MINUS expr  {Keval.SUB ($1,$3) }
    | expr STAR expr { Keval.MUL ($1,$3) }
    | expr SLASH expr { Keval.DIV ($1,$3) }
    | expr EQUAL expr { Keval.EQUAL ($1,$3) }
    | expr LB expr { Keval.LESS ($1,$3) }
    | NOT expr { Keval.NOT ($2) }
    | ID COLONEQ expr { Keval.ASSIGN ($1,$3) }
    | expr SEMICOLON expr { Keval.SEQ ($1,$3) }
    | IF expr THEN expr ELSE expr { Keval.IF2 ($2, $4, $6) }
    | IF expr THEN expr { Keval.IF1 ($2, $4) }
    | WHILE expr DO expr { Keval.WHILE ($2, $4) }
    | FOR ID COLONEQ expr TO expr DO expr { Keval.FOR ($2, $4, $6, $8) }
    | LET ID COLONEQ expr IN expr { Keval.LET ($2, $4, $6) }
    | READ ID { Keval.READ ($2) }
    | WRITE expr { Keval.WRITE ($2) }
    ;

%%
